Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushExpressions.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushExpressions.cs	(revision 14744)
@@ -7,7 +7,9 @@
     protected PushExpression(T state) : base(state) { }
 
-    protected void Eval(IStack<T> stack) {
+    protected bool Eval(IStack<T> stack) {
       stack.Push(this.State);
+      return true;
     }
+
     public override string StringRepresentation { get { return this.State.ToString(); } }
   }
@@ -18,6 +20,6 @@
     }
 
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.IntegerStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.IntegerStack);
     }
   }
@@ -28,6 +30,6 @@
     }
 
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.FloatStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.FloatStack);
     }
   }
@@ -38,6 +40,6 @@
     }
 
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.BooleanStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.BooleanStack);
     }
   }
@@ -48,6 +50,6 @@
     }
 
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.NameStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.NameStack);
     }
   }
@@ -58,6 +60,6 @@
     }
 
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.ExecStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.ExecStack);
     }
   }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushProgram.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushProgram.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushProgram.cs	(revision 14744)
@@ -2,5 +2,4 @@
 
 namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System;
   using System.Diagnostics;
   using System.Linq;
@@ -14,11 +13,19 @@
     private const string Delimiter = " ";
 
+    public static readonly PushProgram Empty = new PushProgram(new Expression[0]);
+
     public readonly IReadOnlyList<Expression> Expressions;
-    public readonly bool IsEmpty;
-
+    public bool IsEmpty { get; private set; }
+
+    public PushProgram(Expression[] expressions) {
+      this.Expressions = expressions;
+      this.IsEmpty = expressions.Length == 0;
+    }
 
     private string stringRepresentation;
-    private string StringRepresentation {
-      get {
+    private string StringRepresentation
+    {
+      get
+      {
         if (string.IsNullOrEmpty(stringRepresentation))
           stringRepresentation = BuildString();
@@ -28,6 +35,8 @@
 
     private int depth = -1;
-    private int Depth {
-      get {
+    private int Depth
+    {
+      get
+      {
         if (depth == -1) depth = CalcDepth();
         return depth;
@@ -36,24 +45,21 @@
 
     private int[] treeIndex = null;
-    public int[] TreeIndex {
-      get {
-        if (treeIndex == null) treeIndex = BuildTreeIndex();
-        return treeIndex;
+    public int[] TreeIndex
+    {
+      get
+      {
+        return this.treeIndex ?? (this.treeIndex = this.BuildTreeIndex());
       }
     }
 
     private int hashCode;
-    private int HashCode {
-      get {
+    private int HashCode
+    {
+      get
+      {
         if (hashCode == default(int)) hashCode = HashExpressions();
         return hashCode;
       }
     }
-
-    public PushProgram(Expression[] expressions) {
-      this.Expressions = expressions;
-      this.IsEmpty = expressions.Length == 0;
-    }
-
 
     public override int GetHashCode() {
@@ -69,9 +75,11 @@
     /// </summary>
     /// <returns></returns>
-    public int TotalCount {
-      get {
+    public int TotalCount
+    {
+      get
+      {
         return this.IsEmpty
             ? 1
-          // + 1 because "this" is also counted
+            // + 1 because "this" is also counted
             : TreeIndex[0] + 1;
       }
@@ -90,12 +98,15 @@
 
     public PushProgram Copy() {
-      var copy = this.CopyExpressions();
-
-      return new PushProgram(copy);
+      return IsEmpty ? this : new PushProgram((Expression[])Expressions) {
+        stringRepresentation = this.stringRepresentation,
+        hashCode = this.hashCode,
+        depth = this.depth,
+        treeIndex = this.treeIndex
+      };
     }
 
     public Expression[] CopyExpressions() {
       var copy = new Expression[this.Expressions.Count];
-      Array.Copy((Expression[])this.Expressions, copy, this.Expressions.Count);
+      ((Expression[])this.Expressions).CopyTo(copy, Expressions.Count);
 
       return copy;
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushResultExpression.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushResultExpression.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushResultExpression.cs	(revision 14744)
@@ -5,18 +5,20 @@
 
   public abstract class PushResultExpression<T> : StatelessExpression {
-    protected void Eval(IStack<T> stack, int count, Func<T[], T> templateFunc) {
-      if (stack.Count < count) return;
+    protected bool Eval(IStack<T> stack, int count, Func<T[], T> templateFunc) {
+      if (stack.Count < count) return false;
 
       stack.PushResult(count, templateFunc);
+      return true;
     }
 
-    protected void Eval(IStack<T> stack, int count, Func<T[], T> templateFunc, T ignoreValue) {
-      if ((stack.Count < count) || stack.Top.Equals(ignoreValue)) return;
+    protected bool Eval(IStack<T> stack, int count, Func<T[], T> templateFunc, T ignoreValue) {
+      if ((stack.Count < count) || stack.Top.Equals(ignoreValue)) return false;
 
       stack.PushResult(count, templateFunc);
+      return true;
     }
 
-    protected void Eval<R>(IStack<T> stack, IStack<R> resultStack, int count, Func<T[], R> templateFunc) {
-      if (stack.Count < count) return;
+    protected bool Eval<R>(IStack<T> stack, IStack<R> resultStack, int count, Func<T[], R> templateFunc) {
+      if (stack.Count < count) return false;
 
       var items = stack.Pop(count);
@@ -24,4 +26,5 @@
 
       resultStack.Push(result);
+      return true;
     }
   }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RandExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RandExpressions.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RandExpressions.cs	(revision 14744)
@@ -10,8 +10,9 @@
   [PushExpression(StackType.Name, "NAME.RAND")]
   public class NameRandExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
+    public override bool Eval(IPushInterpreter interpreter) {
       var name = NameGenerator.RandomName(interpreter.Random);
 
       interpreter.NameStack.Push(name);
+      return true;
     }
   }
@@ -22,5 +23,5 @@
   [PushExpression(StackType.Integer, "INTEGER.RAND")]
   public class IntegerRandExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
+    public override bool Eval(IPushInterpreter interpreter) {
       var value = interpreter.Random.Next(
           interpreter.Configuration.MinRandomInteger,
@@ -28,4 +29,5 @@
 
       interpreter.IntegerStack.Push(value);
+      return true;
     }
   }
@@ -36,8 +38,9 @@
   [PushExpression(StackType.Float, "FLOAT.RAND")]
   public class FloatRandExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
+    public override bool Eval(IPushInterpreter interpreter) {
       var value = interpreter.Random.NextDouble() * (interpreter.Configuration.MaxRandomFloat - interpreter.Configuration.MinRandomFloat) + interpreter.Configuration.MinRandomFloat;
 
       interpreter.FloatStack.Push(value);
+      return true;
     }
   }
@@ -48,8 +51,9 @@
   [PushExpression(StackType.Boolean, "BOOLEAN.RAND")]
   public class BooleanRandExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
+    public override bool Eval(IPushInterpreter interpreter) {
       var value = interpreter.Random.NextDouble() > 0.5;
 
       interpreter.BooleanStack.Push(value);
+      return true;
     }
   }
@@ -60,12 +64,17 @@
   [PushExpression(StackType.Code, "CODE.RAND")]
   public class CodeRandExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
+    public override bool Eval(IPushInterpreter interpreter) {
       if (interpreter.IntegerStack.Count == 0 ||
-          interpreter.IntegerStack.Top < 1) return;
+          interpreter.IntegerStack.Top < 1) return false;
 
       var size = (int)(interpreter.IntegerStack.Pop() % interpreter.Configuration.MaxPointsInRandomExpression);
-      var program = CodeGenerator.RandomExpandExpression(size, interpreter.Random, interpreter.Configuration, interpreter.CustomExpressions);
+      var program = CodeGenerator.RandomExpandExpression(
+        size,
+        interpreter.Random,
+        interpreter.Configuration,
+        interpreter.CustomExpressions);
 
       interpreter.CodeStack.Push(program);
+      return true;
     }
   }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RotateExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RotateExpressions.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RotateExpressions.cs	(revision 14744)
@@ -6,8 +6,9 @@
 
   public abstract class RotateExpression<T> : StatelessExpression {
-    public void Eval(IStack<T> stack) {
-      if (stack.Count < 3) return;
+    public bool Eval(IStack<T> stack) {
+      if (stack.Count < 3) return false;
 
       stack.Swap(3);
+      return true;
     }
   }
@@ -16,6 +17,6 @@
   [PushExpression(StackType.Integer, "INTEGER.ROT")]
   public class IntegerRotateExpression : RotateExpression<long> {
-    public override void Eval(IPushInterpreter interpreter) {
-      Eval(interpreter.IntegerStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.IntegerStack);
     }
   }
@@ -23,6 +24,6 @@
   [PushExpression(StackType.Float, "FLOAT.ROT")]
   public class FloatRotateExpression : RotateExpression<double> {
-    public override void Eval(IPushInterpreter interpreter) {
-      Eval(interpreter.FloatStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.FloatStack);
     }
   }
@@ -30,6 +31,6 @@
   [PushExpression(StackType.Boolean, "BOOLEAN.ROT")]
   public class BooleanRotateExpression : RotateExpression<bool> {
-    public override void Eval(IPushInterpreter interpreter) {
-      Eval(interpreter.BooleanStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.BooleanStack);
     }
   }
@@ -37,6 +38,6 @@
   [PushExpression(StackType.Name, "NAME.ROT")]
   public class NameRotateExpression : RotateExpression<string> {
-    public override void Eval(IPushInterpreter interpreter) {
-      Eval(interpreter.NameStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.NameStack);
     }
   }
@@ -44,6 +45,6 @@
   [PushExpression(StackType.Exec, "EXEC.ROT")]
   public class ExecRotateExpression : RotateExpression<Expression> {
-    public override void Eval(IPushInterpreter interpreter) {
-      Eval(interpreter.ExecStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.ExecStack);
     }
   }
@@ -51,6 +52,6 @@
   [PushExpression(StackType.Code, "CODE.ROT")]
   public class CodeRotateExpression : RotateExpression<Expression> {
-    public override void Eval(IPushInterpreter interpreter) {
-      Eval(interpreter.CodeStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.CodeStack);
     }
   }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ShoveExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ShoveExpressions.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ShoveExpressions.cs	(revision 14744)
@@ -6,10 +6,10 @@
 
   public abstract class ShoveExpression<T> : StatelessExpression {
-    protected void Eval(IStack<T> stack, IStack<long> integerStack, int count = 1) {
+    protected bool Eval(IStack<T> stack, IStack<long> integerStack, int count = 1) {
       if (integerStack.Count == 0 ||
           integerStack.Top > stack.Count - count ||
           integerStack.Top < 0 ||
           stack.Count < 2)
-        return;
+        return false;
 
       var index = (int)integerStack.Pop();
@@ -17,4 +17,5 @@
 
       stack.Insert(index, item);
+      return true;
     }
   }
@@ -22,6 +23,6 @@
   [PushExpression(StackType.Integer, "INTEGER.SHOVE")]
   public class IntegerShoveExpression : ShoveExpression<long> {
-    public override void Eval(IPushInterpreter interpreter) {
-      Eval(interpreter.IntegerStack, interpreter.IntegerStack, 2);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.IntegerStack, interpreter.IntegerStack, 2);
     }
   }
@@ -29,6 +30,6 @@
   [PushExpression(StackType.Float, "FLOAT.SHOVE")]
   public class FloatShoveExpression : ShoveExpression<double> {
-    public override void Eval(IPushInterpreter interpreter) {
-      Eval(interpreter.FloatStack, interpreter.IntegerStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.FloatStack, interpreter.IntegerStack);
     }
   }
@@ -36,6 +37,6 @@
   [PushExpression(StackType.Boolean, "BOOLEAN.SHOVE")]
   public class BooleanShoveExpression : ShoveExpression<bool> {
-    public override void Eval(IPushInterpreter interpreter) {
-      Eval(interpreter.BooleanStack, interpreter.IntegerStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.BooleanStack, interpreter.IntegerStack);
     }
   }
@@ -43,6 +44,6 @@
   [PushExpression(StackType.Name, "NAME.SHOVE")]
   public class NameShoveExpression : ShoveExpression<string> {
-    public override void Eval(IPushInterpreter interpreter) {
-      Eval(interpreter.NameStack, interpreter.IntegerStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.NameStack, interpreter.IntegerStack);
     }
   }
@@ -50,6 +51,6 @@
   [PushExpression(StackType.Exec, "EXEC.SHOVE")]
   public class ExecShoveExpression : ShoveExpression<Expression> {
-    public override void Eval(IPushInterpreter interpreter) {
-      Eval(interpreter.ExecStack, interpreter.IntegerStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.ExecStack, interpreter.IntegerStack);
     }
   }
@@ -57,6 +58,6 @@
   [PushExpression(StackType.Code, "CODE.SHOVE")]
   public class CodeShoveExpression : ShoveExpression<Expression> {
-    public override void Eval(IPushInterpreter interpreter) {
-      Eval(interpreter.CodeStack, interpreter.IntegerStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.CodeStack, interpreter.IntegerStack);
     }
   }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StackdepthExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StackdepthExpressions.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StackdepthExpressions.cs	(revision 14744)
@@ -10,5 +10,5 @@
   /// <typeparam name="T">Stacktype</typeparam>
   public abstract class StackdepthExpression<T> : StatelessExpression {
-    public void Eval(IStack<T> stack, IStack<long> integerStack, bool incremental = false) {
+    public bool Eval(IStack<T> stack, IStack<long> integerStack, bool incremental = false) {
       var count = stack.Count;
 
@@ -16,4 +16,5 @@
 
       integerStack.Push(count);
+      return true;
     }
   }
@@ -22,6 +23,6 @@
   public class IntegerStackdepthExpression : StackdepthExpression<long> {
 
-    public override void Eval(IPushInterpreter interpreter) {
-      Eval(interpreter.IntegerStack, interpreter.IntegerStack, true);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.IntegerStack, interpreter.IntegerStack, true);
     }
   }
@@ -29,6 +30,6 @@
   [PushExpression(StackType.Float, "FLOAT.STACKDEPTH")]
   public class FloatStackdepthExpression : StackdepthExpression<double> {
-    public override void Eval(IPushInterpreter interpreter) {
-      Eval(interpreter.FloatStack, interpreter.IntegerStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.FloatStack, interpreter.IntegerStack);
     }
   }
@@ -36,6 +37,6 @@
   [PushExpression(StackType.Boolean, "BOOLEAN.STACKDEPTH")]
   public class BooleanStackdepthExpression : StackdepthExpression<bool> {
-    public override void Eval(IPushInterpreter interpreter) {
-      Eval(interpreter.BooleanStack, interpreter.IntegerStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.BooleanStack, interpreter.IntegerStack);
     }
   }
@@ -43,6 +44,6 @@
   [PushExpression(StackType.Name, "NAME.STACKDEPTH")]
   public class NameStackdepthExpression : StackdepthExpression<string> {
-    public override void Eval(IPushInterpreter interpreter) {
-      Eval(interpreter.NameStack, interpreter.IntegerStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.NameStack, interpreter.IntegerStack);
     }
   }
@@ -50,6 +51,6 @@
   [PushExpression(StackType.Exec, "EXEC.STACKDEPTH")]
   public class ExecStackdepthExpression : StackdepthExpression<Expression> {
-    public override void Eval(IPushInterpreter interpreter) {
-      Eval(interpreter.ExecStack, interpreter.IntegerStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.ExecStack, interpreter.IntegerStack);
     }
   }
@@ -57,6 +58,6 @@
   [PushExpression(StackType.Code, "CODE.STACKDEPTH")]
   public class CodeStackdepthExpression : StackdepthExpression<Expression> {
-    public override void Eval(IPushInterpreter interpreter) {
-      Eval(interpreter.CodeStack, interpreter.IntegerStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.CodeStack, interpreter.IntegerStack);
     }
   }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StatefulExpression.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StatefulExpression.cs	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StatefulExpression.cs	(revision 14744)
@@ -0,0 +1,43 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Data.Pool;
+
+  public abstract class StatefulExpression<T> : Expression
+  {
+    public readonly T State;
+
+    private int hashCode;
+    private int HashCode
+    {
+      get
+      {
+        if (hashCode == default(int)) hashCode = CalcHashCode();
+        return hashCode;
+      }
+    }
+
+    protected StatefulExpression(T state) {
+      this.State = state;
+    }
+
+    protected virtual int CalcHashCode() {
+      return this.State.GetHashCode();
+    }
+
+    public override bool Equals(object obj) {
+      if (ReferenceEquals(this, obj))
+        return true;
+
+      if (this.GetType() != obj.GetType())
+        return false;
+
+      var other = (StatefulExpression<T>)obj;
+
+      return ReferenceEquals(this.State, other.State) ||
+             this.GetHashCode() == other.GetHashCode();
+    }
+
+    public override int GetHashCode() {
+      return HashCode;
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/SwapExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/SwapExpressions.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/SwapExpressions.cs	(revision 14744)
@@ -10,9 +10,10 @@
   /// <typeparam name="T">Stacktype</typeparam>
   public abstract class SwapExpression<T> : StatelessExpression {
-    public void Eval(IStack<T> stack) {
+    public bool Eval(IStack<T> stack) {
       if (stack.Count < 2)
-        return;
+        return false;
 
       stack.Swap(2);
+      return true;
     }
   }
@@ -20,6 +21,6 @@
   [PushExpression(StackType.Integer, "INTEGER.SWAP")]
   public class IntegerSwapExpression : SwapExpression<long> {
-    public override void Eval(IPushInterpreter interpreter) {
-      Eval(interpreter.IntegerStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.IntegerStack);
     }
   }
@@ -27,6 +28,6 @@
   [PushExpression(StackType.Float, "FLOAT.SWAP")]
   public class FloatSwapExpression : SwapExpression<double> {
-    public override void Eval(IPushInterpreter interpreter) {
-      Eval(interpreter.FloatStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.FloatStack);
     }
   }
@@ -34,6 +35,6 @@
   [PushExpression(StackType.Boolean, "BOOLEAN.SWAP")]
   public class BooleanSwapExpression : SwapExpression<bool> {
-    public override void Eval(IPushInterpreter interpreter) {
-      Eval(interpreter.BooleanStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.BooleanStack);
     }
   }
@@ -41,6 +42,6 @@
   [PushExpression(StackType.Name, "NAME.SWAP")]
   public class NameSwapExpression : SwapExpression<string> {
-    public override void Eval(IPushInterpreter interpreter) {
-      Eval(interpreter.NameStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.NameStack);
     }
   }
@@ -48,6 +49,6 @@
   [PushExpression(StackType.Exec, "EXEC.SWAP")]
   public class ExecSwapExpression : SwapExpression<Expression> {
-    public override void Eval(IPushInterpreter interpreter) {
-      Eval(interpreter.ExecStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.ExecStack);
     }
   }
@@ -55,6 +56,6 @@
   [PushExpression(StackType.Code, "CODE.SWAP")]
   public class CodeSwapExpression : SwapExpression<Expression> {
-    public override void Eval(IPushInterpreter interpreter) {
-      Eval(interpreter.CodeStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.CodeStack);
     }
   }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/YankDuplicateExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/YankDuplicateExpressions.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/YankDuplicateExpressions.cs	(revision 14744)
@@ -10,17 +10,25 @@
   /// <typeparam name="T">Stacktype</typeparam>
   public abstract class YankDuplicateExpression<T> : StatelessExpression {
-    public void Eval(IStack<T> stack, IStack<long> integerStack) {
+    public bool Eval(IStack<T> stack, IStack<long> integerStack) {
       T item;
-      if (this.TryGetItem(stack, integerStack, out item)) stack.Push(item);
+      if (!this.TryGetItem(stack, integerStack, out item))
+        return false;
+
+      stack.Push(item);
+      return true;
     }
 
-    public void Eval(IStack<Expression> stack, IStack<long> integerStack) {
+    public bool Eval(IStack<Expression> stack, IStack<long> integerStack) {
       Expression item;
-      if (this.TryGetItem(stack, integerStack, out item)) stack.Push(item);
+      if (!this.TryGetItem(stack, integerStack, out item))
+        return false;
+
+      stack.Push(item);
+      return true;
     }
 
-    public void Eval(IStack<long> integerStack) {
+    public bool Eval(IStack<long> integerStack) {
       if ((integerStack.Count < 2) || (integerStack.Top > integerStack.Count - 2) ||
-          (integerStack.Top < 0)) return;
+          (integerStack.Top < 0)) return false;
 
       var index = (int)integerStack.Pop();
@@ -28,4 +36,5 @@
 
       integerStack.Push(item);
+      return true;
     }
 
@@ -48,6 +57,6 @@
   [PushExpression(StackType.Integer, "INTEGER.YANKDUP")]
   public class IntegerYankDuplicateExpression : YankDuplicateExpression<long> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.IntegerStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return this.Eval(interpreter.IntegerStack);
     }
   }
@@ -55,6 +64,6 @@
   [PushExpression(StackType.Float, "FLOAT.YANKDUP")]
   public class FloatYankDuplicateExpression : YankDuplicateExpression<double> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.FloatStack, interpreter.IntegerStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return this.Eval(interpreter.FloatStack, interpreter.IntegerStack);
     }
   }
@@ -62,6 +71,6 @@
   [PushExpression(StackType.Boolean, "BOOLEAN.YANKDUP")]
   public class BooleanYankDuplicateExpression : YankDuplicateExpression<bool> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.BooleanStack, interpreter.IntegerStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return this.Eval(interpreter.BooleanStack, interpreter.IntegerStack);
     }
   }
@@ -69,6 +78,6 @@
   [PushExpression(StackType.Name, "NAME.YANKDUP")]
   public class NameYankDuplicateExpression : YankDuplicateExpression<string> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.NameStack, interpreter.IntegerStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return this.Eval(interpreter.NameStack, interpreter.IntegerStack);
     }
   }
@@ -76,6 +85,6 @@
   [PushExpression(StackType.Exec, "EXEC.YANKDUP")]
   public class ExecYankDuplicateExpression : YankDuplicateExpression<Expression> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.ExecStack, interpreter.IntegerStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return this.Eval(interpreter.ExecStack, interpreter.IntegerStack);
     }
   }
@@ -83,6 +92,6 @@
   [PushExpression(StackType.Code, "CODE.YANKDUP")]
   public class CodeYankDuplicateExpression : YankDuplicateExpression<Expression> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.CodeStack, interpreter.IntegerStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return this.Eval(interpreter.CodeStack, interpreter.IntegerStack);
     }
   }
